#include <bits/stdc++.h>

//#define int long long
#define double long double
using namespace std;
//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("popcnt,avx2,fma")
const long long N = 2e5 + 10, inf = 1e18;
mt19937 rnd(time(nullptr));

struct pt {
    int x, y;

    pt(int xx = 0, int yy = 0) : x(xx), y(yy) {}
};

struct vec {
    long long x, y;

    vec(long long xx = 0, long long yy = 0) : x(xx), y(yy) {}

    vec(pt a, pt b) : x(b.x - a.x), y(b.y - a.y) {}

    double len() {
        return sqrtl(x * x + y * y);
    }

    double operator%(vec const a) {
        return x * a.y - y * a.x;
    }

    vec turn() {
        return {-y, x};
    }
};

vector<pt> a(15);
double g[15][15];
vector<int> us(15);

double rec(int v, int n, int w = 0) {
    us[v] = 1;
    int q = -1;
    for (int i = 0; i < n; i++) {
        if (us[i] == 0) {
            if (q == -1 || g[v][q] > g[v][i])q = i;
        }
    }
    if (w == n - 1)return g[v][q];
    else return g[v][q] + rec(q, n, w + 1);
}

double solve(vec x, int n) {
    int i, j;
    vec y = x.turn();
    for (i = 0; i < n; i++) {
        for (j = i + 1; j < n; j++) {
            vec q(a[i], a[j]);
            g[i][j] = abs(q % x) / x.len() + abs(q % y) / y.len();
            g[j][i] = g[i][j];
        }
    }
    double q = inf;
    for (i = 0; i < n; i++) {
        for (j = 0; j < n; j++)us[j] = 0;
        q = min(q, rec(i, n));
    }
    return q;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, i, j;
    cin >> n;
    for (i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
    }
    double ans = inf;
    for (i = 0; i < n; i++) {
        for (j = i + 1; j < n; j++) {
            ans = min(ans, solve(vec(a[i], a[j]), n));
        }
    }
    for (int i1 = 0; i1 <= 5e5; i1++) {
        i = rnd() % 1000000;
        j = rnd() % 1000000;
        ans = min(ans, solve(vec(i, j), n));
        ans = min(ans, solve(vec(-i, j), n));
        ans = min(ans, solve(vec(i, -j), n));
        ans = min(ans, solve(vec(-i, -j), n));
    }
    cout.precision(15);
    cout << ans;
    return 0;
}